# Importações necessárias
import os
import re
import time
import pymysql
from pymysql import err
from selenium.webdriver import Firefox
from selenium.webdriver.firefox.options import Options

# Função para conectar ao banco de dados MySQL
def conectar_banco():
    # Configurações de conexão com o banco de dados MySQL
    db_host = "187.45.179.18"
    db_user = "colibexcom_user"
    db_pass = "wo3dZ}@*eS$%"
    db_name = "colibexcom_banco"

    # Conectar ao banco de dados MySQL
    return pymysql.connect(host=db_host, user=db_user, password=db_pass, database=db_name)

# Função para capturar os dados
# Função para capturar os dados
def captura(estado, categoria, cursor, conn):
    print("Capturando dados para estado:", estado, "e categoria:", categoria)

    # Configurar as opções do Firefox
    opcoes = Options()
    opcoes.headless = False  # Define como True se desejar que o navegador seja invisível
    opcoes.add_argument("--width=10")  # Define a largura da janela do navegador
    opcoes.add_argument("--height=100")  # Define a altura da janela do navegador

    # Inicializar o driver do Firefox com as opções configuradas
    navegador = Firefox(options=opcoes)

    # Abrir a URL no navegador
    navegador.get("https://venda-imoveis.caixa.gov.br/sistema/busca-imovel.asp")

    time.sleep(2)

    # Injetar script JavaScript para enviar a requisição AJAX
    script = f"""
    var xhr = new XMLHttpRequest();
    var url = "https://venda-imoveis.caixa.gov.br/sistema/carregaPesquisaImoveis.asp";
    var parametros = "hdn_estado={estado}&hdn_cidade=&hdn_tp_venda={categoria}";

    xhr.open("POST", url, true);
    xhr.setRequestHeader("Content-type", "application/x-www-form-urlencoded");

    xhr.onreadystatechange = function() {{
        if (xhr.readyState == 4 && xhr.status == 200) {{
            document.documentElement.innerHTML = xhr.responseText;
        }}
    }}

    xhr.send(parametros);
    """
    print('Injetando código JavaScript')

    # Executar o script JavaScript
    navegador.execute_script(script)

    time.sleep(5)

    # Extrair o HTML da página
    html_pagina = navegador.page_source


    print()

    # Verificar se o HTML contém as palavras-chave
    if "Nenhum imóvel" in html_pagina or "encontrado" in html_pagina:
        print("Achou Seguindo")
        with open('log.txt', 'a') as log_file:
            log_file.write(f"{estado}-{categoria}\n")
        time.sleep(1)

    else:
        print("Aguardando mais 20 segundos")
        tentativas = 4
        for _ in range(tentativas):
            time.sleep(20)  # Aguardar 20 segundos
            # Extrair o HTML da página
            html_pagina = navegador.page_source
            if "Nenhum imóvel" in html_pagina or "encontrado" in html_pagina:
                print("Achou Seguindo")
                with open('log.txt', 'a') as log_file:
                    log_file.write(f"{estado}-{categoria}\n")
                time.sleep(1)
                break
            else:
                print("Tentativa", _+1, "de", tentativas, "- Reiniciando consulta...")
                navegador.refresh()  # Atualizar a página para tentar novamente
        else:  # Se não houver sucesso após as tentativas
            print("Erro ao capturar os dados após", tentativas, "tentativas. Reiniciando...")
            with open('log.txt', 'a') as log_file:
                    log_file.write(f"{estado}-{categoria}\n")
            navegador.quit()  # Fechar o navegador antes de reiniciar
            captura(estado, categoria, cursor, conn)  # Reiniciar o processo

    padrao = r'id="hdnImov\d+" value="(.+?)"'
    valores = re.findall(padrao, html_pagina)

    print(valores)
    for valor in valores:
        ids = valor.split("||")
        for id_imovel in ids:
            # Tentar executar o SQL e lidar com erros
            while True:
                try:
                    sql_insert = f"INSERT IGNORE INTO `z_imoveis_caixa`(`id_imovel`, `id_cidade`, `uf`) VALUES ('{id_imovel}', '0', '{estado}')"
                    print(sql_insert)
                    cursor.execute(sql_insert)
                    break  # Sai do loop se a inserção for bem-sucedida
                except err.OperationalError as e:
                    if e.args[0] == 2006:
                        print("Reconectando ao banco de dados...")
                        conn.close()
                        conn = conectar_banco()
                        cursor = conn.cursor()
                        print("Conexão reestabelecida. Tentando inserir novamente...")
                    else:
                        raise  # Lança a exceção se não for um erro de conexão

    # Confirmar a inserção
    conn.commit()

    # Fechar o navegador
    navegador.quit()


# Lista de siglas dos estados em maiúsculas
estados = ["SP", "MG", "RJ", "AC", "AL", "AP", "AM", "BA", "CE", "DF", "ES", "GO", "MA", "MT", "MS",  "PA", "PB", "PR", "PE", "PI",  "RN", "RS", "RO", "RR", "SC", "SE", "TO"]

# Lista de categorias
categorias = [34, 33, 4, 5, 2, 14, 21, 9]

# Verificar se o arquivo de log existe, caso contrário, criá-lo e preenchê-lo com todas as combinações de estados e categorias
if not os.path.exists('log.txt'):
    with open('log.txt', 'w') as log_file:
        for estado in estados:
            for categoria in categorias:
                log_file.write(f"{estado}-{categoria}\n")

# Conectar ao banco de dados MySQL
conn = conectar_banco()
cursor = conn.cursor()

# Verificar se há um arquivo de log existente
try:
    with open('log.txt', 'r') as log_file:
        linhas = log_file.readlines()
        estados_executados = [linha.strip() for linha in linhas]

except FileNotFoundError:
    estados_executados = []

# Iterar sobre cada estado e categoria
for estado in estados:
    for categoria in categorias:
        chave = f"{estado}-{categoria}"
        if chave not in estados_executados:
            captura(estado, categoria, cursor, conn)
            # Registrar o estado e categoria no arquivo de log
            estados_executados.append(chave)

# Limpar a listagem de estados e categorias
open('log.txt', 'w').close()

# Fechar a conexão com o banco de dados
conn.close()
